pub mod uci;
pub mod bitboard;
pub mod movegen;
pub mod engine;
pub mod board;
pub mod evaluate;
pub mod search;
pub mod zobrist;
pub mod ttable;
pub mod settings;
pub mod magic;

extern crate log;
extern crate simplelog;
extern crate rand;
extern crate static_assertions;

use engine::Engine;

fn main() {

    /*let board = Board::from_fen_str("1k1r3q/1ppn3p/p4b2/4p3/8/P2N2P1/1PP1R1BP/2K1Q3 w - - 0 0").unwrap();
    //let see = movegen::see_score::<false>(board.clone(), 35, false);
    let see = movegen::calculate_see(board.clone(), movegen::Move::Default { mov: SimpleMove{ from: 20, to: 35 }, pc: PieceCaptureType::new(KNIGHT, Some(PAWN)) }, false);
    println!("see: {}", see);*/

    let mut engine = Engine::new();
    engine.run();
}


